# -*- coding: cp1252 -*-
# fakultaet.py

# Beispiele fr das Arbeiten mit Fakultten

## ===== rekursiv =====
def fakr(n):
    if n==0: return 1
    return n*fakr(n-1)

print( 5, " : ", fakr(5) )
print( 10, " : ", fakr(10) )
print( 'Das geht ohne stack overflow gut bis in die Grenordnung von 1000' )

## ===== iterativ =====
def faki(n):
    ergebnis=1
    for i in range(1, n+1): ergebnis=ergebnis*i
    return ergebnis

print( 5, " : ", faki(5) )
print( 10, " : ", faki(10) )
# print( 2000, " : ", faki(2000) ) # geht natrlich

## ===== Binomialkoeffizient =====
def binomi(n, k):
    return faki(n)/(faki(k)*faki(n-k))

print( 'Auswahl 6 aus 49', binomi(49, 6) )

## ===== Binomialverteilung =====
def binVert(n, p):
    ergebnis=[]
    for k in range(n+1):
        ergebnis.append(binomi(n, k)*pow(p, k)*pow(1-p, n-k))
    return ergebnis

print( 'Binomialverteilung n=10, p=0,1', binVert(10, 0.1) )

## ===== summierte Binomialverteilung =====
def SumBinVert(n, p):
    ergebnis=[]
    for k in range(n+1):
        ergebnis.append(binomi(n, k)*pow(p, k)*pow(1-p, n-k))
        if k>0: ergebnis[k]+=ergebnis[k-1]
    return ergebnis

print( 'Summen-Binomialverteilung n=10, p=0,1', SumBinVert(10, 0.1) )


